
#include "Atomic/robbery/robberyADVISE.h"
#include <stdlib.h>
#include <iostream>
#include <math.h>


robberyADVISE::robberyADVISE() {
  ImpersonateCustomertoObtainMoneyAD.setParent(this);
  DoNothingAD.setParent(this);
  WriteDownAccountInformationAD.setParent(this);
  ImpersonateCustomertoObtainMoneyFailure.setParent(this);
  ImpersonateCustomertoObtainMoneySuccess.setParent(this);
  DoNothingOutcome1.setParent(this);
  WriteDownAccountInformationSuccess.setParent(this);
  ImpersonateCustomertoObtainMoneyGroup.initialize(2, "ImpersonateCustomertoObtainMoneyGroup");
  ImpersonateCustomertoObtainMoneyGroup.appendGroup((BaseGroupClass*) &ImpersonateCustomertoObtainMoneyFailure);
  ImpersonateCustomertoObtainMoneyGroup.appendGroup((BaseGroupClass*) &ImpersonateCustomertoObtainMoneySuccess);

  AdversaryDecisionGroup.initialize(3, "AdversaryDecisionGroup");
  AdversaryDecisionGroup.appendGroup((BaseGroupClass*) &ImpersonateCustomertoObtainMoneyAD);
  AdversaryDecisionGroup.appendGroup((BaseGroupClass*) &DoNothingAD);
  AdversaryDecisionGroup.appendGroup((BaseGroupClass*) &WriteDownAccountInformationAD);

  BaseADVISEAction* InitialActions[7] = {
    &ImpersonateCustomertoObtainMoneyAD, // 0
    &DoNothingAD, // 1
    &WriteDownAccountInformationAD, // 2
    &ImpersonateCustomertoObtainMoneyFailure, // 3
    &ImpersonateCustomertoObtainMoneySuccess, // 4
    &DoNothingOutcome1, // 5
    &WriteDownAccountInformationSuccess // 6
  };

  Step* InitialSteps[4] = {
      &ImpersonateCustomertoObtainMoneyFailure,
      &ImpersonateCustomertoObtainMoneySuccess,
      &DoNothingOutcome1,
      &WriteDownAccountInformationSuccess
  };

  BaseGroupClass* InitialGroups[4] = {
    (BaseGroupClass*) &ImpersonateCustomertoObtainMoneyGroup, // 0
    (BaseGroupClass*) &DoNothingOutcome1, // 1
    (BaseGroupClass*) &WriteDownAccountInformationSuccess, // 2
    (BaseGroupClass*) &AdversaryDecisionGroup
  };

  InsiderKnowledge = new Knowledge("InsiderKnowledge", 1);
  CustomerInformation = new Knowledge("CustomerInformation", 0);
  Money = new Goal("Money", 0);
  Money->setPayoff(1000);
  MakeDecision = new BeginAdversaryDecision("MakeDecision", 0);
  ImpersonateCustomertoObtainMoneyWeight = new StepWeight("ImpersonateCustomertoObtainMoneyWeight", 0);
  ImpersonateCustomertoObtainMoneyChosen = new StepChosen("ImpersonateCustomertoObtainMoneyChosen", 0);
  DoNothingWeight = new StepWeight("DoNothingWeight", 0);
  DoNothingChosen = new StepChosen("DoNothingChosen", 0);
  WriteDownAccountInformationWeight = new StepWeight("WriteDownAccountInformationWeight", 0);
  WriteDownAccountInformationChosen = new StepChosen("WriteDownAccountInformationChosen", 0);

  Goal* InitialGoals[1] = {
      Money
  };

  ADVISEStateVariable* InitialSVs[10] = {
    InsiderKnowledge, // 0
    CustomerInformation, // 1
    Money, // 2
    ImpersonateCustomertoObtainMoneyChosen, // 3
    DoNothingChosen, // 4
    WriteDownAccountInformationChosen, // 5
    ImpersonateCustomertoObtainMoneyWeight, // 6
    DoNothingWeight, // 7
    WriteDownAccountInformationWeight, // 8
    MakeDecision // 9
};

  int outCounts[3] = { 2, 1, 1 };

  commonInit("robbery", 10, InitialSVs, 7, InitialActions, 4, InitialGroups, 3, outCounts, InitialSteps, 1, InitialGoals);

  advCostPref = 0;
  advDetectPref = 0.2;
  advPayPref = 0.8;

  planningHorizon = 2;
  costDiscount = 1.0;
  detectionDiscount = 1.0;
  payoffDiscount = 1.0;

  assignSVsToAttackSteps();

  int AffectArcs[35][2] = {
    {9,0}, {3,0}, {6,0}, {9,1}, {4,1}, {7,1}, {9,2}, {5,2}, 
    {8,2}, {9,3}, {3,3}, {6,3}, {7,3}, {8,3}, {2,3}, {1,3}, 
    {9,4}, {3,4}, {6,4}, {7,4}, {8,4}, {2,4}, {1,4}, {9,5}, 
    {4,5}, {6,5}, {7,5}, {8,5}, {9,6}, {5,6}, {6,6}, {7,6}, 
    {8,6}, {1,6}, {0,6}
};
  for(int n = 0; n < 35;n++)
    AddAffectArc(InitialSVs[AffectArcs[n][0]], InitialActions[AffectArcs[n][1]]);
  int EnableArcs[10][2] = {
    {9,0}, {9,1}, {9,2}, {3,3}, {2,3}, {3,4}, {2,4}, {4,5}, 
    {5,6}, {1,6}
};
  for(int n = 0; n < 10;n++)
    AddEnableArc(InitialSVs[EnableArcs[n][0]], InitialActions[EnableArcs[n][1]]);
  for(int x = 0; x < 7; x++) {
    InitialActions[x]->LinkVariables();
  }

  customInitialization();

  recalculateAdversaryDecisionWeights();

}

robberyADVISE::~robberyADVISE() {
}

void robberyADVISE::assignSVsToAttackSteps() {
  ImpersonateCustomertoObtainMoneyFailure.Money = Money;
  ImpersonateCustomertoObtainMoneyFailure.CustomerInformation = CustomerInformation;
  ImpersonateCustomertoObtainMoneyFailure.ImpersonateCustomertoObtainMoneyChosen = ImpersonateCustomertoObtainMoneyChosen;
  ImpersonateCustomertoObtainMoneyFailure.ImpersonateCustomertoObtainMoneyWeight = ImpersonateCustomertoObtainMoneyWeight;
  ImpersonateCustomertoObtainMoneyFailure.DoNothingWeight = DoNothingWeight;
  ImpersonateCustomertoObtainMoneyFailure.WriteDownAccountInformationWeight = WriteDownAccountInformationWeight;
  ImpersonateCustomertoObtainMoneyFailure.MakeDecision = MakeDecision;
  ImpersonateCustomertoObtainMoneyFailure.setSVs(ImpersonateCustomertoObtainMoneyChosen, ImpersonateCustomertoObtainMoneyWeight);
  ImpersonateCustomertoObtainMoneySuccess.Money = Money;
  ImpersonateCustomertoObtainMoneySuccess.CustomerInformation = CustomerInformation;
  ImpersonateCustomertoObtainMoneySuccess.ImpersonateCustomertoObtainMoneyChosen = ImpersonateCustomertoObtainMoneyChosen;
  ImpersonateCustomertoObtainMoneySuccess.ImpersonateCustomertoObtainMoneyWeight = ImpersonateCustomertoObtainMoneyWeight;
  ImpersonateCustomertoObtainMoneySuccess.DoNothingWeight = DoNothingWeight;
  ImpersonateCustomertoObtainMoneySuccess.WriteDownAccountInformationWeight = WriteDownAccountInformationWeight;
  ImpersonateCustomertoObtainMoneySuccess.MakeDecision = MakeDecision;
  ImpersonateCustomertoObtainMoneySuccess.setSVs(ImpersonateCustomertoObtainMoneyChosen, ImpersonateCustomertoObtainMoneyWeight);
  DoNothingOutcome1.DoNothingChosen = DoNothingChosen;
  DoNothingOutcome1.ImpersonateCustomertoObtainMoneyWeight = ImpersonateCustomertoObtainMoneyWeight;
  DoNothingOutcome1.DoNothingWeight = DoNothingWeight;
  DoNothingOutcome1.WriteDownAccountInformationWeight = WriteDownAccountInformationWeight;
  DoNothingOutcome1.MakeDecision = MakeDecision;
  DoNothingOutcome1.setSVs(DoNothingChosen, DoNothingWeight);
  WriteDownAccountInformationSuccess.CustomerInformation = CustomerInformation;
  WriteDownAccountInformationSuccess.InsiderKnowledge = InsiderKnowledge;
  WriteDownAccountInformationSuccess.WriteDownAccountInformationChosen = WriteDownAccountInformationChosen;
  WriteDownAccountInformationSuccess.ImpersonateCustomertoObtainMoneyWeight = ImpersonateCustomertoObtainMoneyWeight;
  WriteDownAccountInformationSuccess.DoNothingWeight = DoNothingWeight;
  WriteDownAccountInformationSuccess.WriteDownAccountInformationWeight = WriteDownAccountInformationWeight;
  WriteDownAccountInformationSuccess.MakeDecision = MakeDecision;
  WriteDownAccountInformationSuccess.setSVs(WriteDownAccountInformationChosen, WriteDownAccountInformationWeight);

  ImpersonateCustomertoObtainMoneyAD.MakeDecision = MakeDecision;
  ImpersonateCustomertoObtainMoneyAD.ImpersonateCustomertoObtainMoneyChosen = ImpersonateCustomertoObtainMoneyChosen;
  ImpersonateCustomertoObtainMoneyAD.ImpersonateCustomertoObtainMoneyWeight = ImpersonateCustomertoObtainMoneyWeight;
  DoNothingAD.MakeDecision = MakeDecision;
  DoNothingAD.DoNothingChosen = DoNothingChosen;
  DoNothingAD.DoNothingWeight = DoNothingWeight;
  WriteDownAccountInformationAD.MakeDecision = MakeDecision;
  WriteDownAccountInformationAD.WriteDownAccountInformationChosen = WriteDownAccountInformationChosen;
  WriteDownAccountInformationAD.WriteDownAccountInformationWeight = WriteDownAccountInformationWeight;
}

double robberyADVISE::convertCostToUtility(double cost) {
  const double esquared = 7.389056099; // e^(2)
  if(cost < 0)
    return 1.0;
  else if(cost > 100)
    return 0.0;
  else {
    return (esquared - exp(cost/50))/(-1 + esquared);
  }
}

double robberyADVISE::convertPayoffToUtility(double payoff) {
  const double etoten = 28.031624895; // e^(10/3)
  if(payoff < 0)
    return 0;
  else if(payoff > 1000)
    return 1;
  else {
    return (etoten - (etoten/exp(payoff/300)))/(-1 + etoten);
  }
}

double robberyADVISE::convertDetectionToUtility(double detection) {
  const double esquared = 7.389056099; // e^(2)
  if(detection < 0)
    return 1;
  else if(detection > 1)
    return 0;
  else {
    return (1-(esquared/exp(2*detection)))/(1-esquared);
  }
}

void robberyADVISE::customInitialization() {

}

/*****************************************************************/
/*                   Attack Step Definitions                     */
/*****************************************************************/

/*====================== ImpersonateCustomertoObtainMoneyFailureStep ========================*/

robberyADVISE::ImpersonateCustomertoObtainMoneyFailureStep::ImpersonateCustomertoObtainMoneyFailureStep() {
  TheDistributionParameters = new double[1];
  commonInit("ImpersonateCustomertoObtainMoneyFailureStep", 0, Deterministic, RaceEnabled, 7, 1, false);}

robberyADVISE::ImpersonateCustomertoObtainMoneyFailureStep::~ImpersonateCustomertoObtainMoneyFailureStep() {
  delete[] TheDistributionParameters;
}

void robberyADVISE::ImpersonateCustomertoObtainMoneyFailureStep::LinkVariables() {
  Money->Register(&Money_Mobius_Mark);
  CustomerInformation->Register(&CustomerInformation_Mobius_Mark);
  ImpersonateCustomertoObtainMoneyChosen->Register(&ImpersonateCustomertoObtainMoneyChosen_Mobius_Mark);
  ImpersonateCustomertoObtainMoneyWeight->Register(&ImpersonateCustomertoObtainMoneyWeight_Mobius_Mark);
  DoNothingWeight->Register(&DoNothingWeight_Mobius_Mark);
  WriteDownAccountInformationWeight->Register(&WriteDownAccountInformationWeight_Mobius_Mark);
  MakeDecision->Register(&MakeDecision_Mobius_Mark);

}

bool robberyADVISE::ImpersonateCustomertoObtainMoneyFailureStep::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(ImpersonateCustomertoObtainMoneyChosen_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robberyADVISE::ImpersonateCustomertoObtainMoneyFailureStep::timeDistributionParameter0() {
return 10;
}

double robberyADVISE::ImpersonateCustomertoObtainMoneyFailureStep::Weight() {
return 0.3;
}

bool robberyADVISE::ImpersonateCustomertoObtainMoneyFailureStep::ReactivationPredicate() {
  return false;
}

bool robberyADVISE::ImpersonateCustomertoObtainMoneyFailureStep::ReactivationFunction() {
  return false;
}

double robberyADVISE::ImpersonateCustomertoObtainMoneyFailureStep::SampleDistribution() {
  return TheDistribution->Deterministic(timeDistributionParameter0());
}

double *robberyADVISE::ImpersonateCustomertoObtainMoneyFailureStep::ReturnDistributionParameters() {
  TheDistributionParameters[0] = timeDistributionParameter0();
  return TheDistributionParameters;
}

int robberyADVISE::ImpersonateCustomertoObtainMoneyFailureStep::Rank() {
  return 1;
}

bool robberyADVISE::ImpersonateCustomertoObtainMoneyFailureStep::preconditionsMet() {
return (CustomerInformation->Mark() && !Money->Mark());
  return true;
}

void robberyADVISE::ImpersonateCustomertoObtainMoneyFailureStep::executeEffects() {

}

double robberyADVISE::ImpersonateCustomertoObtainMoneyFailureStep::getCost() {
return 0;
}

double robberyADVISE::ImpersonateCustomertoObtainMoneyFailureStep::getOutcomeProbability() {
return 0.3;
}

double robberyADVISE::ImpersonateCustomertoObtainMoneyFailureStep::getDetection() {
return 0.9;
}

/*====================== ImpersonateCustomertoObtainMoneySuccessStep ========================*/

robberyADVISE::ImpersonateCustomertoObtainMoneySuccessStep::ImpersonateCustomertoObtainMoneySuccessStep() {
  TheDistributionParameters = new double[1];
  commonInit("ImpersonateCustomertoObtainMoneySuccessStep", 0, Deterministic, RaceEnabled, 7, 1, false);}

robberyADVISE::ImpersonateCustomertoObtainMoneySuccessStep::~ImpersonateCustomertoObtainMoneySuccessStep() {
  delete[] TheDistributionParameters;
}

void robberyADVISE::ImpersonateCustomertoObtainMoneySuccessStep::LinkVariables() {
  Money->Register(&Money_Mobius_Mark);
  CustomerInformation->Register(&CustomerInformation_Mobius_Mark);
  ImpersonateCustomertoObtainMoneyChosen->Register(&ImpersonateCustomertoObtainMoneyChosen_Mobius_Mark);
  ImpersonateCustomertoObtainMoneyWeight->Register(&ImpersonateCustomertoObtainMoneyWeight_Mobius_Mark);
  DoNothingWeight->Register(&DoNothingWeight_Mobius_Mark);
  WriteDownAccountInformationWeight->Register(&WriteDownAccountInformationWeight_Mobius_Mark);
  MakeDecision->Register(&MakeDecision_Mobius_Mark);

}

bool robberyADVISE::ImpersonateCustomertoObtainMoneySuccessStep::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(ImpersonateCustomertoObtainMoneyChosen_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robberyADVISE::ImpersonateCustomertoObtainMoneySuccessStep::timeDistributionParameter0() {
return 10;
}

double robberyADVISE::ImpersonateCustomertoObtainMoneySuccessStep::Weight() {
return 0.7;
}

bool robberyADVISE::ImpersonateCustomertoObtainMoneySuccessStep::ReactivationPredicate() {
  return false;
}

bool robberyADVISE::ImpersonateCustomertoObtainMoneySuccessStep::ReactivationFunction() {
  return false;
}

double robberyADVISE::ImpersonateCustomertoObtainMoneySuccessStep::SampleDistribution() {
  return TheDistribution->Deterministic(timeDistributionParameter0());
}

double *robberyADVISE::ImpersonateCustomertoObtainMoneySuccessStep::ReturnDistributionParameters() {
  TheDistributionParameters[0] = timeDistributionParameter0();
  return TheDistributionParameters;
}

int robberyADVISE::ImpersonateCustomertoObtainMoneySuccessStep::Rank() {
  return 1;
}

bool robberyADVISE::ImpersonateCustomertoObtainMoneySuccessStep::preconditionsMet() {
return (CustomerInformation->Mark() && !Money->Mark());
  return true;
}

void robberyADVISE::ImpersonateCustomertoObtainMoneySuccessStep::executeEffects() {
Money->Mark() = true;
}

double robberyADVISE::ImpersonateCustomertoObtainMoneySuccessStep::getCost() {
return 0;
}

double robberyADVISE::ImpersonateCustomertoObtainMoneySuccessStep::getOutcomeProbability() {
return 0.7;
}

double robberyADVISE::ImpersonateCustomertoObtainMoneySuccessStep::getDetection() {
return 0;
}

/*====================== DoNothingOutcome1Step ========================*/

robberyADVISE::DoNothingOutcome1Step::DoNothingOutcome1Step() {
  TheDistributionParameters = new double[1];
  commonInit("DoNothingOutcome1Step", 1, Deterministic, RaceEnabled, 5, 0, false);}

robberyADVISE::DoNothingOutcome1Step::~DoNothingOutcome1Step() {
  delete[] TheDistributionParameters;
}

void robberyADVISE::DoNothingOutcome1Step::LinkVariables() {
  DoNothingChosen->Register(&DoNothingChosen_Mobius_Mark);
  ImpersonateCustomertoObtainMoneyWeight->Register(&ImpersonateCustomertoObtainMoneyWeight_Mobius_Mark);
  DoNothingWeight->Register(&DoNothingWeight_Mobius_Mark);
  WriteDownAccountInformationWeight->Register(&WriteDownAccountInformationWeight_Mobius_Mark);
  MakeDecision->Register(&MakeDecision_Mobius_Mark);

}

bool robberyADVISE::DoNothingOutcome1Step::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(DoNothingChosen_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robberyADVISE::DoNothingOutcome1Step::timeDistributionParameter0() {
return 1;
}

double robberyADVISE::DoNothingOutcome1Step::Weight() {
  return 1;
}

bool robberyADVISE::DoNothingOutcome1Step::ReactivationPredicate() {
  return false;
}

bool robberyADVISE::DoNothingOutcome1Step::ReactivationFunction() {
  return false;
}

double robberyADVISE::DoNothingOutcome1Step::SampleDistribution() {
  return TheDistribution->Deterministic(timeDistributionParameter0());
}

double *robberyADVISE::DoNothingOutcome1Step::ReturnDistributionParameters() {
  TheDistributionParameters[0] = timeDistributionParameter0();
  return TheDistributionParameters;
}

int robberyADVISE::DoNothingOutcome1Step::Rank() {
  return 1;
}

bool robberyADVISE::DoNothingOutcome1Step::preconditionsMet() {

  return true;
}

void robberyADVISE::DoNothingOutcome1Step::executeEffects() {

}

double robberyADVISE::DoNothingOutcome1Step::getCost() {
return 0;
}

double robberyADVISE::DoNothingOutcome1Step::getOutcomeProbability() {
return 1;
}

double robberyADVISE::DoNothingOutcome1Step::getDetection() {
return 0;
}

/*====================== WriteDownAccountInformationSuccessStep ========================*/

robberyADVISE::WriteDownAccountInformationSuccessStep::WriteDownAccountInformationSuccessStep() {
  TheDistributionParameters = new double[1];
  commonInit("WriteDownAccountInformationSuccessStep", 2, Deterministic, RaceEnabled, 7, 1, false);}

robberyADVISE::WriteDownAccountInformationSuccessStep::~WriteDownAccountInformationSuccessStep() {
  delete[] TheDistributionParameters;
}

void robberyADVISE::WriteDownAccountInformationSuccessStep::LinkVariables() {
  CustomerInformation->Register(&CustomerInformation_Mobius_Mark);
  InsiderKnowledge->Register(&InsiderKnowledge_Mobius_Mark);
  WriteDownAccountInformationChosen->Register(&WriteDownAccountInformationChosen_Mobius_Mark);
  ImpersonateCustomertoObtainMoneyWeight->Register(&ImpersonateCustomertoObtainMoneyWeight_Mobius_Mark);
  DoNothingWeight->Register(&DoNothingWeight_Mobius_Mark);
  WriteDownAccountInformationWeight->Register(&WriteDownAccountInformationWeight_Mobius_Mark);
  MakeDecision->Register(&MakeDecision_Mobius_Mark);

}

bool robberyADVISE::WriteDownAccountInformationSuccessStep::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(WriteDownAccountInformationChosen_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robberyADVISE::WriteDownAccountInformationSuccessStep::timeDistributionParameter0() {
return 5;
}

double robberyADVISE::WriteDownAccountInformationSuccessStep::Weight() {
  return 1;
}

bool robberyADVISE::WriteDownAccountInformationSuccessStep::ReactivationPredicate() {
  return false;
}

bool robberyADVISE::WriteDownAccountInformationSuccessStep::ReactivationFunction() {
  return false;
}

double robberyADVISE::WriteDownAccountInformationSuccessStep::SampleDistribution() {
  return TheDistribution->Deterministic(timeDistributionParameter0());
}

double *robberyADVISE::WriteDownAccountInformationSuccessStep::ReturnDistributionParameters() {
  TheDistributionParameters[0] = timeDistributionParameter0();
  return TheDistributionParameters;
}

int robberyADVISE::WriteDownAccountInformationSuccessStep::Rank() {
  return 1;
}

bool robberyADVISE::WriteDownAccountInformationSuccessStep::preconditionsMet() {
return (!CustomerInformation->Mark() && InsiderKnowledge->Mark());
  return true;
}

void robberyADVISE::WriteDownAccountInformationSuccessStep::executeEffects() {
CustomerInformation->Mark() = true;
}

double robberyADVISE::WriteDownAccountInformationSuccessStep::getCost() {
return 0;
}

double robberyADVISE::WriteDownAccountInformationSuccessStep::getOutcomeProbability() {
return 1;
}

double robberyADVISE::WriteDownAccountInformationSuccessStep::getDetection() {
return 0.1;
}

/*****************************************************************/
/*                   Adversary Decisions                         */
/*****************************************************************/

/*====================== ImpersonateCustomertoObtainMoneyAdversaryDecision ========================*/

robberyADVISE::ImpersonateCustomertoObtainMoneyAdversaryDecision::ImpersonateCustomertoObtainMoneyAdversaryDecision() {
  commonInit("ImpersonateCustomertoObtainMoneyAdversaryDecision", 3, Instantaneous, RaceEnabled, 2, 1, false);
}

robberyADVISE::ImpersonateCustomertoObtainMoneyAdversaryDecision::~ImpersonateCustomertoObtainMoneyAdversaryDecision() {
}

void robberyADVISE::ImpersonateCustomertoObtainMoneyAdversaryDecision::LinkVariables() {
  MakeDecision->Register(&MakeDecision_Mobius_Mark);
  ImpersonateCustomertoObtainMoneyChosen->Register(&ImpersonateCustomertoObtainMoneyChosen_Mobius_Mark);
  ImpersonateCustomertoObtainMoneyWeight->Register(&ImpersonateCustomertoObtainMoneyWeight_Mobius_Mark);
}

bool robberyADVISE::ImpersonateCustomertoObtainMoneyAdversaryDecision::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(MakeDecision_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robberyADVISE::ImpersonateCustomertoObtainMoneyAdversaryDecision::Weight() {
  return ImpersonateCustomertoObtainMoneyWeight->Mark();
}

bool robberyADVISE::ImpersonateCustomertoObtainMoneyAdversaryDecision::ReactivationPredicate() {
  return false;
}

bool robberyADVISE::ImpersonateCustomertoObtainMoneyAdversaryDecision::ReactivationFunction() {
  return false;
}

double robberyADVISE::ImpersonateCustomertoObtainMoneyAdversaryDecision::SampleDistribution() {
  return 0;
}

double* robberyADVISE::ImpersonateCustomertoObtainMoneyAdversaryDecision::ReturnDistributionParameters() {
  return NULL;
}

int robberyADVISE::ImpersonateCustomertoObtainMoneyAdversaryDecision::Rank() {
  return 1;
}

BaseActionClass* robberyADVISE::ImpersonateCustomertoObtainMoneyAdversaryDecision::Fire() {
  (*(MakeDecision_Mobius_Mark))--;
  (*(ImpersonateCustomertoObtainMoneyWeight_Mobius_Mark))--;
  (*(ImpersonateCustomertoObtainMoneyChosen_Mobius_Mark))++;
  return this;
}

/*====================== DoNothingAdversaryDecision ========================*/

robberyADVISE::DoNothingAdversaryDecision::DoNothingAdversaryDecision() {
  commonInit("DoNothingAdversaryDecision", 3, Instantaneous, RaceEnabled, 2, 1, false);
}

robberyADVISE::DoNothingAdversaryDecision::~DoNothingAdversaryDecision() {
}

void robberyADVISE::DoNothingAdversaryDecision::LinkVariables() {
  MakeDecision->Register(&MakeDecision_Mobius_Mark);
  DoNothingChosen->Register(&DoNothingChosen_Mobius_Mark);
  DoNothingWeight->Register(&DoNothingWeight_Mobius_Mark);
}

bool robberyADVISE::DoNothingAdversaryDecision::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(MakeDecision_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robberyADVISE::DoNothingAdversaryDecision::Weight() {
  return DoNothingWeight->Mark();
}

bool robberyADVISE::DoNothingAdversaryDecision::ReactivationPredicate() {
  return false;
}

bool robberyADVISE::DoNothingAdversaryDecision::ReactivationFunction() {
  return false;
}

double robberyADVISE::DoNothingAdversaryDecision::SampleDistribution() {
  return 0;
}

double* robberyADVISE::DoNothingAdversaryDecision::ReturnDistributionParameters() {
  return NULL;
}

int robberyADVISE::DoNothingAdversaryDecision::Rank() {
  return 1;
}

BaseActionClass* robberyADVISE::DoNothingAdversaryDecision::Fire() {
  (*(MakeDecision_Mobius_Mark))--;
  (*(DoNothingWeight_Mobius_Mark))--;
  (*(DoNothingChosen_Mobius_Mark))++;
  return this;
}

/*====================== WriteDownAccountInformationAdversaryDecision ========================*/

robberyADVISE::WriteDownAccountInformationAdversaryDecision::WriteDownAccountInformationAdversaryDecision() {
  commonInit("WriteDownAccountInformationAdversaryDecision", 3, Instantaneous, RaceEnabled, 2, 1, false);
}

robberyADVISE::WriteDownAccountInformationAdversaryDecision::~WriteDownAccountInformationAdversaryDecision() {
}

void robberyADVISE::WriteDownAccountInformationAdversaryDecision::LinkVariables() {
  MakeDecision->Register(&MakeDecision_Mobius_Mark);
  WriteDownAccountInformationChosen->Register(&WriteDownAccountInformationChosen_Mobius_Mark);
  WriteDownAccountInformationWeight->Register(&WriteDownAccountInformationWeight_Mobius_Mark);
}

bool robberyADVISE::WriteDownAccountInformationAdversaryDecision::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(MakeDecision_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robberyADVISE::WriteDownAccountInformationAdversaryDecision::Weight() {
  return WriteDownAccountInformationWeight->Mark();
}

bool robberyADVISE::WriteDownAccountInformationAdversaryDecision::ReactivationPredicate() {
  return false;
}

bool robberyADVISE::WriteDownAccountInformationAdversaryDecision::ReactivationFunction() {
  return false;
}

double robberyADVISE::WriteDownAccountInformationAdversaryDecision::SampleDistribution() {
  return 0;
}

double* robberyADVISE::WriteDownAccountInformationAdversaryDecision::ReturnDistributionParameters() {
  return NULL;
}

int robberyADVISE::WriteDownAccountInformationAdversaryDecision::Rank() {
  return 1;
}

BaseActionClass* robberyADVISE::WriteDownAccountInformationAdversaryDecision::Fire() {
  (*(MakeDecision_Mobius_Mark))--;
  (*(WriteDownAccountInformationWeight_Mobius_Mark))--;
  (*(WriteDownAccountInformationChosen_Mobius_Mark))++;
  return this;
}

