
#include "Atomic/robbery/robberyADVISE.h"
#include <stdlib.h>
#include <iostream>
#include <math.h>


robberyADVISE::robberyADVISE() {
  DoNothingAD.setParent(this);
  WriteDownAccountInformationAD.setParent(this);
  ImpersonateCustomerToObtainMoneyAD.setParent(this);
  DoNothingOutcome1.setParent(this);
  DoNothingOutcome1.setParent(this);
  DoNothingOutcome1.setParent(this);
  WriteDownAccountInformationOutcome1.setParent(this);
  ImpersonateCustomerToObtainMoneyOutcome1.setParent(this);
  ImpersonateCustomerToObtainMoneyOutcome1.setParent(this);
  ImpersonateCustomerToObtainMoneyFailure.setParent(this);
  ImpersonateCustomerToObtainMoneySuccess.setParent(this);
  DoNothingGroup.initialize(3, "DoNothingGroup");
  DoNothingGroup.appendGroup((BaseGroupClass*) &DoNothingOutcome1);
  DoNothingGroup.appendGroup((BaseGroupClass*) &DoNothingOutcome1);
  DoNothingGroup.appendGroup((BaseGroupClass*) &DoNothingOutcome1);

  ImpersonateCustomerToObtainMoneyGroup.initialize(4, "ImpersonateCustomerToObtainMoneyGroup");
  ImpersonateCustomerToObtainMoneyGroup.appendGroup((BaseGroupClass*) &ImpersonateCustomerToObtainMoneyOutcome1);
  ImpersonateCustomerToObtainMoneyGroup.appendGroup((BaseGroupClass*) &ImpersonateCustomerToObtainMoneyOutcome1);
  ImpersonateCustomerToObtainMoneyGroup.appendGroup((BaseGroupClass*) &ImpersonateCustomerToObtainMoneyFailure);
  ImpersonateCustomerToObtainMoneyGroup.appendGroup((BaseGroupClass*) &ImpersonateCustomerToObtainMoneySuccess);

  AdversaryDecisionGroup.initialize(3, "AdversaryDecisionGroup");
  AdversaryDecisionGroup.appendGroup((BaseGroupClass*) &DoNothingAD);
  AdversaryDecisionGroup.appendGroup((BaseGroupClass*) &WriteDownAccountInformationAD);
  AdversaryDecisionGroup.appendGroup((BaseGroupClass*) &ImpersonateCustomerToObtainMoneyAD);

  BaseADVISEAction* InitialActions[11] = {
    &DoNothingAD, // 0
    &WriteDownAccountInformationAD, // 1
    &ImpersonateCustomerToObtainMoneyAD, // 2
    &DoNothingOutcome1, // 3
    &DoNothingOutcome1, // 4
    &DoNothingOutcome1, // 5
    &WriteDownAccountInformationOutcome1, // 6
    &ImpersonateCustomerToObtainMoneyOutcome1, // 7
    &ImpersonateCustomerToObtainMoneyOutcome1, // 8
    &ImpersonateCustomerToObtainMoneyFailure, // 9
    &ImpersonateCustomerToObtainMoneySuccess // 10
  };

  Step* InitialSteps[8] = {
      &DoNothingOutcome1,
      &DoNothingOutcome1,
      &DoNothingOutcome1,
      &WriteDownAccountInformationOutcome1,
      &ImpersonateCustomerToObtainMoneyOutcome1,
      &ImpersonateCustomerToObtainMoneyOutcome1,
      &ImpersonateCustomerToObtainMoneyFailure,
      &ImpersonateCustomerToObtainMoneySuccess
  };

  BaseGroupClass* InitialGroups[4] = {
    (BaseGroupClass*) &DoNothingGroup, // 0
    (BaseGroupClass*) &WriteDownAccountInformationOutcome1, // 1
    (BaseGroupClass*) &ImpersonateCustomerToObtainMoneyGroup, // 2
    (BaseGroupClass*) &AdversaryDecisionGroup
  };

  InsiderKnowledge = new Knowledge("InsiderKnowledge", 1);
  CustomerInformation = new Knowledge("CustomerInformation", 0);
  Money = new Goal("Money", 0);
  Money->setPayoff(1000);
  MakeDecision = new BeginAdversaryDecision("MakeDecision", 0);
  DoNothingWeight = new StepWeight("DoNothingWeight", 0);
  DoNothingChosen = new StepChosen("DoNothingChosen", 0);
  WriteDownAccountInformationWeight = new StepWeight("WriteDownAccountInformationWeight", 0);
  WriteDownAccountInformationChosen = new StepChosen("WriteDownAccountInformationChosen", 0);
  ImpersonateCustomerToObtainMoneyWeight = new StepWeight("ImpersonateCustomerToObtainMoneyWeight", 0);
  ImpersonateCustomerToObtainMoneyChosen = new StepChosen("ImpersonateCustomerToObtainMoneyChosen", 0);

  Goal* InitialGoals[1] = {
      Money
  };

  ADVISEStateVariable* InitialSVs[10] = {
    InsiderKnowledge, // 0
    CustomerInformation, // 1
    Money, // 2
    DoNothingChosen, // 3
    WriteDownAccountInformationChosen, // 4
    ImpersonateCustomerToObtainMoneyChosen, // 5
    DoNothingWeight, // 6
    WriteDownAccountInformationWeight, // 7
    ImpersonateCustomerToObtainMoneyWeight, // 8
    MakeDecision // 9
};

  int outCounts[3] = { 3, 1, 4 };

  commonInit("robbery", 10, InitialSVs, 11, InitialActions, 4, InitialGroups, 3, outCounts, InitialSteps, 1, InitialGoals);

  advCostPref = 0;
  advDetectPref = 0.2;
  advPayPref = 0.8;

  planningHorizon = 2;
  costDiscount = 1.0;
  detectionDiscount = 1.0;
  payoffDiscount = 1.0;

  assignSVsToAttackSteps();

  int AffectArcs[59][2] = {
    {9,0}, {3,0}, {6,0}, {9,1}, {4,1}, {7,1}, {9,2}, {5,2}, 
    {8,2}, {9,3}, {3,3}, {6,3}, {7,3}, {8,3}, {9,4}, {3,4}, 
    {6,4}, {7,4}, {8,4}, {9,5}, {3,5}, {6,5}, {7,5}, {8,5}, 
    {9,6}, {4,6}, {6,6}, {7,6}, {8,6}, {1,6}, {0,6}, {9,7}, 
    {5,7}, {6,7}, {7,7}, {8,7}, {2,7}, {1,7}, {9,8}, {5,8}, 
    {6,8}, {7,8}, {8,8}, {2,8}, {1,8}, {9,9}, {5,9}, {6,9}, 
    {7,9}, {8,9}, {2,9}, {1,9}, {9,10}, {5,10}, {6,10}, {7,10}, 
    {8,10}, {2,10}, {1,10}
};
  for(int n = 0; n < 59;n++)
    AddAffectArc(InitialSVs[AffectArcs[n][0]], InitialActions[AffectArcs[n][1]]);
  int EnableArcs[16][2] = {
    {9,0}, {9,1}, {9,2}, {3,3}, {3,4}, {3,5}, {4,6}, {1,6}, 
    {5,7}, {2,7}, {5,8}, {2,8}, {5,9}, {2,9}, {5,10}, {2,10}
    
};
  for(int n = 0; n < 16;n++)
    AddEnableArc(InitialSVs[EnableArcs[n][0]], InitialActions[EnableArcs[n][1]]);
  for(int x = 0; x < 11; x++) {
    InitialActions[x]->LinkVariables();
  }

  customInitialization();

  recalculateAdversaryDecisionWeights();

}

robberyADVISE::~robberyADVISE() {
}

void robberyADVISE::assignSVsToAttackSteps() {
  DoNothingOutcome1.DoNothingChosen = DoNothingChosen;
  DoNothingOutcome1.DoNothingWeight = DoNothingWeight;
  DoNothingOutcome1.WriteDownAccountInformationWeight = WriteDownAccountInformationWeight;
  DoNothingOutcome1.ImpersonateCustomerToObtainMoneyWeight = ImpersonateCustomerToObtainMoneyWeight;
  DoNothingOutcome1.MakeDecision = MakeDecision;
  DoNothingOutcome1.setSVs(DoNothingChosen, DoNothingWeight);
  DoNothingOutcome1.DoNothingChosen = DoNothingChosen;
  DoNothingOutcome1.DoNothingWeight = DoNothingWeight;
  DoNothingOutcome1.WriteDownAccountInformationWeight = WriteDownAccountInformationWeight;
  DoNothingOutcome1.ImpersonateCustomerToObtainMoneyWeight = ImpersonateCustomerToObtainMoneyWeight;
  DoNothingOutcome1.MakeDecision = MakeDecision;
  DoNothingOutcome1.setSVs(DoNothingChosen, DoNothingWeight);
  DoNothingOutcome1.DoNothingChosen = DoNothingChosen;
  DoNothingOutcome1.DoNothingWeight = DoNothingWeight;
  DoNothingOutcome1.WriteDownAccountInformationWeight = WriteDownAccountInformationWeight;
  DoNothingOutcome1.ImpersonateCustomerToObtainMoneyWeight = ImpersonateCustomerToObtainMoneyWeight;
  DoNothingOutcome1.MakeDecision = MakeDecision;
  DoNothingOutcome1.setSVs(DoNothingChosen, DoNothingWeight);
  WriteDownAccountInformationOutcome1.CustomerInformation = CustomerInformation;
  WriteDownAccountInformationOutcome1.InsiderKnowledge = InsiderKnowledge;
  WriteDownAccountInformationOutcome1.WriteDownAccountInformationChosen = WriteDownAccountInformationChosen;
  WriteDownAccountInformationOutcome1.DoNothingWeight = DoNothingWeight;
  WriteDownAccountInformationOutcome1.WriteDownAccountInformationWeight = WriteDownAccountInformationWeight;
  WriteDownAccountInformationOutcome1.ImpersonateCustomerToObtainMoneyWeight = ImpersonateCustomerToObtainMoneyWeight;
  WriteDownAccountInformationOutcome1.MakeDecision = MakeDecision;
  WriteDownAccountInformationOutcome1.setSVs(WriteDownAccountInformationChosen, WriteDownAccountInformationWeight);
  ImpersonateCustomerToObtainMoneyOutcome1.Money = Money;
  ImpersonateCustomerToObtainMoneyOutcome1.CustomerInformation = CustomerInformation;
  ImpersonateCustomerToObtainMoneyOutcome1.ImpersonateCustomerToObtainMoneyChosen = ImpersonateCustomerToObtainMoneyChosen;
  ImpersonateCustomerToObtainMoneyOutcome1.DoNothingWeight = DoNothingWeight;
  ImpersonateCustomerToObtainMoneyOutcome1.WriteDownAccountInformationWeight = WriteDownAccountInformationWeight;
  ImpersonateCustomerToObtainMoneyOutcome1.ImpersonateCustomerToObtainMoneyWeight = ImpersonateCustomerToObtainMoneyWeight;
  ImpersonateCustomerToObtainMoneyOutcome1.MakeDecision = MakeDecision;
  ImpersonateCustomerToObtainMoneyOutcome1.setSVs(ImpersonateCustomerToObtainMoneyChosen, ImpersonateCustomerToObtainMoneyWeight);
  ImpersonateCustomerToObtainMoneyOutcome1.Money = Money;
  ImpersonateCustomerToObtainMoneyOutcome1.CustomerInformation = CustomerInformation;
  ImpersonateCustomerToObtainMoneyOutcome1.ImpersonateCustomerToObtainMoneyChosen = ImpersonateCustomerToObtainMoneyChosen;
  ImpersonateCustomerToObtainMoneyOutcome1.DoNothingWeight = DoNothingWeight;
  ImpersonateCustomerToObtainMoneyOutcome1.WriteDownAccountInformationWeight = WriteDownAccountInformationWeight;
  ImpersonateCustomerToObtainMoneyOutcome1.ImpersonateCustomerToObtainMoneyWeight = ImpersonateCustomerToObtainMoneyWeight;
  ImpersonateCustomerToObtainMoneyOutcome1.MakeDecision = MakeDecision;
  ImpersonateCustomerToObtainMoneyOutcome1.setSVs(ImpersonateCustomerToObtainMoneyChosen, ImpersonateCustomerToObtainMoneyWeight);
  ImpersonateCustomerToObtainMoneyFailure.Money = Money;
  ImpersonateCustomerToObtainMoneyFailure.CustomerInformation = CustomerInformation;
  ImpersonateCustomerToObtainMoneyFailure.ImpersonateCustomerToObtainMoneyChosen = ImpersonateCustomerToObtainMoneyChosen;
  ImpersonateCustomerToObtainMoneyFailure.DoNothingWeight = DoNothingWeight;
  ImpersonateCustomerToObtainMoneyFailure.WriteDownAccountInformationWeight = WriteDownAccountInformationWeight;
  ImpersonateCustomerToObtainMoneyFailure.ImpersonateCustomerToObtainMoneyWeight = ImpersonateCustomerToObtainMoneyWeight;
  ImpersonateCustomerToObtainMoneyFailure.MakeDecision = MakeDecision;
  ImpersonateCustomerToObtainMoneyFailure.setSVs(ImpersonateCustomerToObtainMoneyChosen, ImpersonateCustomerToObtainMoneyWeight);
  ImpersonateCustomerToObtainMoneySuccess.Money = Money;
  ImpersonateCustomerToObtainMoneySuccess.CustomerInformation = CustomerInformation;
  ImpersonateCustomerToObtainMoneySuccess.ImpersonateCustomerToObtainMoneyChosen = ImpersonateCustomerToObtainMoneyChosen;
  ImpersonateCustomerToObtainMoneySuccess.DoNothingWeight = DoNothingWeight;
  ImpersonateCustomerToObtainMoneySuccess.WriteDownAccountInformationWeight = WriteDownAccountInformationWeight;
  ImpersonateCustomerToObtainMoneySuccess.ImpersonateCustomerToObtainMoneyWeight = ImpersonateCustomerToObtainMoneyWeight;
  ImpersonateCustomerToObtainMoneySuccess.MakeDecision = MakeDecision;
  ImpersonateCustomerToObtainMoneySuccess.setSVs(ImpersonateCustomerToObtainMoneyChosen, ImpersonateCustomerToObtainMoneyWeight);

  DoNothingAD.MakeDecision = MakeDecision;
  DoNothingAD.DoNothingChosen = DoNothingChosen;
  DoNothingAD.DoNothingWeight = DoNothingWeight;
  WriteDownAccountInformationAD.MakeDecision = MakeDecision;
  WriteDownAccountInformationAD.WriteDownAccountInformationChosen = WriteDownAccountInformationChosen;
  WriteDownAccountInformationAD.WriteDownAccountInformationWeight = WriteDownAccountInformationWeight;
  ImpersonateCustomerToObtainMoneyAD.MakeDecision = MakeDecision;
  ImpersonateCustomerToObtainMoneyAD.ImpersonateCustomerToObtainMoneyChosen = ImpersonateCustomerToObtainMoneyChosen;
  ImpersonateCustomerToObtainMoneyAD.ImpersonateCustomerToObtainMoneyWeight = ImpersonateCustomerToObtainMoneyWeight;
}

double robberyADVISE::convertCostToUtility(double cost) {
  const double esquared = 7.389056099; // e^(2)
  if(cost < 0)
    return 1.0;
  else if(cost > 100)
    return 0.0;
  else {
    return (esquared - exp(cost/50))/(-1 + esquared);
  }
}

double robberyADVISE::convertPayoffToUtility(double payoff) {
  const double etoten = 28.031624895; // e^(10/3)
  if(payoff < 0)
    return 0;
  else if(payoff > 1000)
    return 1;
  else {
    return (etoten - (etoten/exp(payoff/300)))/(-1 + etoten);
  }
}

double robberyADVISE::convertDetectionToUtility(double detection) {
  const double esquared = 7.389056099; // e^(2)
  if(detection < 0)
    return 1;
  else if(detection > 1)
    return 0;
  else {
    return (1-(esquared/exp(2*detection)))/(1-esquared);
  }
}

void robberyADVISE::customInitialization() {

}

/*****************************************************************/
/*                   Attack Step Definitions                     */
/*****************************************************************/

/*====================== DoNothingOutcome1Step ========================*/

robberyADVISE::DoNothingOutcome1Step::DoNothingOutcome1Step() {
  TheDistributionParameters = new double[1];
  commonInit("DoNothingOutcome1Step", 0, Deterministic, RaceEnabled, 5, 0, false);}

robberyADVISE::DoNothingOutcome1Step::~DoNothingOutcome1Step() {
  delete[] TheDistributionParameters;
}

void robberyADVISE::DoNothingOutcome1Step::LinkVariables() {
  DoNothingChosen->Register(&DoNothingChosen_Mobius_Mark);
  DoNothingWeight->Register(&DoNothingWeight_Mobius_Mark);
  WriteDownAccountInformationWeight->Register(&WriteDownAccountInformationWeight_Mobius_Mark);
  ImpersonateCustomerToObtainMoneyWeight->Register(&ImpersonateCustomerToObtainMoneyWeight_Mobius_Mark);
  MakeDecision->Register(&MakeDecision_Mobius_Mark);

}

bool robberyADVISE::DoNothingOutcome1Step::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(DoNothingChosen_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robberyADVISE::DoNothingOutcome1Step::timeDistributionParameter0() {
return 1;
}

double robberyADVISE::DoNothingOutcome1Step::Weight() {
return 1;
}

bool robberyADVISE::DoNothingOutcome1Step::ReactivationPredicate() {
  return false;
}

bool robberyADVISE::DoNothingOutcome1Step::ReactivationFunction() {
  return false;
}

double robberyADVISE::DoNothingOutcome1Step::SampleDistribution() {
  return TheDistribution->Deterministic(timeDistributionParameter0());
}

double *robberyADVISE::DoNothingOutcome1Step::ReturnDistributionParameters() {
  TheDistributionParameters[0] = timeDistributionParameter0();
  return TheDistributionParameters;
}

int robberyADVISE::DoNothingOutcome1Step::Rank() {
  return 1;
}

bool robberyADVISE::DoNothingOutcome1Step::preconditionsMet() {

  return true;
}

void robberyADVISE::DoNothingOutcome1Step::executeEffects() {

}

double robberyADVISE::DoNothingOutcome1Step::getCost() {
return 0;
}

double robberyADVISE::DoNothingOutcome1Step::getOutcomeProbability() {
return 1;
}

double robberyADVISE::DoNothingOutcome1Step::getDetection() {
return 0;
}

/*====================== DoNothingOutcome1Step ========================*/

robberyADVISE::DoNothingOutcome1Step::DoNothingOutcome1Step() {
  TheDistributionParameters = new double[1];
  commonInit("DoNothingOutcome1Step", 0, Deterministic, RaceEnabled, 5, 0, false);}

robberyADVISE::DoNothingOutcome1Step::~DoNothingOutcome1Step() {
  delete[] TheDistributionParameters;
}

void robberyADVISE::DoNothingOutcome1Step::LinkVariables() {
  DoNothingChosen->Register(&DoNothingChosen_Mobius_Mark);
  DoNothingWeight->Register(&DoNothingWeight_Mobius_Mark);
  WriteDownAccountInformationWeight->Register(&WriteDownAccountInformationWeight_Mobius_Mark);
  ImpersonateCustomerToObtainMoneyWeight->Register(&ImpersonateCustomerToObtainMoneyWeight_Mobius_Mark);
  MakeDecision->Register(&MakeDecision_Mobius_Mark);

}

bool robberyADVISE::DoNothingOutcome1Step::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(DoNothingChosen_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robberyADVISE::DoNothingOutcome1Step::timeDistributionParameter0() {
return 1;
}

double robberyADVISE::DoNothingOutcome1Step::Weight() {
return 1;
}

bool robberyADVISE::DoNothingOutcome1Step::ReactivationPredicate() {
  return false;
}

bool robberyADVISE::DoNothingOutcome1Step::ReactivationFunction() {
  return false;
}

double robberyADVISE::DoNothingOutcome1Step::SampleDistribution() {
  return TheDistribution->Deterministic(timeDistributionParameter0());
}

double *robberyADVISE::DoNothingOutcome1Step::ReturnDistributionParameters() {
  TheDistributionParameters[0] = timeDistributionParameter0();
  return TheDistributionParameters;
}

int robberyADVISE::DoNothingOutcome1Step::Rank() {
  return 1;
}

bool robberyADVISE::DoNothingOutcome1Step::preconditionsMet() {

  return true;
}

void robberyADVISE::DoNothingOutcome1Step::executeEffects() {

}

double robberyADVISE::DoNothingOutcome1Step::getCost() {
return 0;
}

double robberyADVISE::DoNothingOutcome1Step::getOutcomeProbability() {
return 1;
}

double robberyADVISE::DoNothingOutcome1Step::getDetection() {
return 0;
}

/*====================== DoNothingOutcome1Step ========================*/

robberyADVISE::DoNothingOutcome1Step::DoNothingOutcome1Step() {
  TheDistributionParameters = new double[1];
  commonInit("DoNothingOutcome1Step", 0, Deterministic, RaceEnabled, 5, 0, false);}

robberyADVISE::DoNothingOutcome1Step::~DoNothingOutcome1Step() {
  delete[] TheDistributionParameters;
}

void robberyADVISE::DoNothingOutcome1Step::LinkVariables() {
  DoNothingChosen->Register(&DoNothingChosen_Mobius_Mark);
  DoNothingWeight->Register(&DoNothingWeight_Mobius_Mark);
  WriteDownAccountInformationWeight->Register(&WriteDownAccountInformationWeight_Mobius_Mark);
  ImpersonateCustomerToObtainMoneyWeight->Register(&ImpersonateCustomerToObtainMoneyWeight_Mobius_Mark);
  MakeDecision->Register(&MakeDecision_Mobius_Mark);

}

bool robberyADVISE::DoNothingOutcome1Step::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(DoNothingChosen_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robberyADVISE::DoNothingOutcome1Step::timeDistributionParameter0() {
return 1;
}

double robberyADVISE::DoNothingOutcome1Step::Weight() {
return 1;
}

bool robberyADVISE::DoNothingOutcome1Step::ReactivationPredicate() {
  return false;
}

bool robberyADVISE::DoNothingOutcome1Step::ReactivationFunction() {
  return false;
}

double robberyADVISE::DoNothingOutcome1Step::SampleDistribution() {
  return TheDistribution->Deterministic(timeDistributionParameter0());
}

double *robberyADVISE::DoNothingOutcome1Step::ReturnDistributionParameters() {
  TheDistributionParameters[0] = timeDistributionParameter0();
  return TheDistributionParameters;
}

int robberyADVISE::DoNothingOutcome1Step::Rank() {
  return 1;
}

bool robberyADVISE::DoNothingOutcome1Step::preconditionsMet() {

  return true;
}

void robberyADVISE::DoNothingOutcome1Step::executeEffects() {

}

double robberyADVISE::DoNothingOutcome1Step::getCost() {
return 0;
}

double robberyADVISE::DoNothingOutcome1Step::getOutcomeProbability() {
return 1;
}

double robberyADVISE::DoNothingOutcome1Step::getDetection() {
return 0;
}

/*====================== WriteDownAccountInformationOutcome1Step ========================*/

robberyADVISE::WriteDownAccountInformationOutcome1Step::WriteDownAccountInformationOutcome1Step() {
  TheDistributionParameters = new double[1];
  commonInit("WriteDownAccountInformationOutcome1Step", 1, Deterministic, RaceEnabled, 7, 1, false);}

robberyADVISE::WriteDownAccountInformationOutcome1Step::~WriteDownAccountInformationOutcome1Step() {
  delete[] TheDistributionParameters;
}

void robberyADVISE::WriteDownAccountInformationOutcome1Step::LinkVariables() {
  CustomerInformation->Register(&CustomerInformation_Mobius_Mark);
  InsiderKnowledge->Register(&InsiderKnowledge_Mobius_Mark);
  WriteDownAccountInformationChosen->Register(&WriteDownAccountInformationChosen_Mobius_Mark);
  DoNothingWeight->Register(&DoNothingWeight_Mobius_Mark);
  WriteDownAccountInformationWeight->Register(&WriteDownAccountInformationWeight_Mobius_Mark);
  ImpersonateCustomerToObtainMoneyWeight->Register(&ImpersonateCustomerToObtainMoneyWeight_Mobius_Mark);
  MakeDecision->Register(&MakeDecision_Mobius_Mark);

}

bool robberyADVISE::WriteDownAccountInformationOutcome1Step::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(WriteDownAccountInformationChosen_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robberyADVISE::WriteDownAccountInformationOutcome1Step::timeDistributionParameter0() {
return 5;
}

double robberyADVISE::WriteDownAccountInformationOutcome1Step::Weight() {
  return 1;
}

bool robberyADVISE::WriteDownAccountInformationOutcome1Step::ReactivationPredicate() {
  return false;
}

bool robberyADVISE::WriteDownAccountInformationOutcome1Step::ReactivationFunction() {
  return false;
}

double robberyADVISE::WriteDownAccountInformationOutcome1Step::SampleDistribution() {
  return TheDistribution->Deterministic(timeDistributionParameter0());
}

double *robberyADVISE::WriteDownAccountInformationOutcome1Step::ReturnDistributionParameters() {
  TheDistributionParameters[0] = timeDistributionParameter0();
  return TheDistributionParameters;
}

int robberyADVISE::WriteDownAccountInformationOutcome1Step::Rank() {
  return 1;
}

bool robberyADVISE::WriteDownAccountInformationOutcome1Step::preconditionsMet() {
return (!CustomerInformation->Mark() && InsiderKnowledge->Mark());
  return true;
}

void robberyADVISE::WriteDownAccountInformationOutcome1Step::executeEffects() {

}

double robberyADVISE::WriteDownAccountInformationOutcome1Step::getCost() {
return 0;
}

double robberyADVISE::WriteDownAccountInformationOutcome1Step::getOutcomeProbability() {
return 1;
}

double robberyADVISE::WriteDownAccountInformationOutcome1Step::getDetection() {
return 0;
}

/*====================== ImpersonateCustomerToObtainMoneyOutcome1Step ========================*/

robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::ImpersonateCustomerToObtainMoneyOutcome1Step() {
  TheDistributionParameters = new double[1];
  commonInit("ImpersonateCustomerToObtainMoneyOutcome1Step", 2, Deterministic, RaceEnabled, 7, 1, false);}

robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::~ImpersonateCustomerToObtainMoneyOutcome1Step() {
  delete[] TheDistributionParameters;
}

void robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::LinkVariables() {
  Money->Register(&Money_Mobius_Mark);
  CustomerInformation->Register(&CustomerInformation_Mobius_Mark);
  ImpersonateCustomerToObtainMoneyChosen->Register(&ImpersonateCustomerToObtainMoneyChosen_Mobius_Mark);
  DoNothingWeight->Register(&DoNothingWeight_Mobius_Mark);
  WriteDownAccountInformationWeight->Register(&WriteDownAccountInformationWeight_Mobius_Mark);
  ImpersonateCustomerToObtainMoneyWeight->Register(&ImpersonateCustomerToObtainMoneyWeight_Mobius_Mark);
  MakeDecision->Register(&MakeDecision_Mobius_Mark);

}

bool robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(ImpersonateCustomerToObtainMoneyChosen_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::timeDistributionParameter0() {
return 10;
}

double robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::Weight() {
return 1;
}

bool robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::ReactivationPredicate() {
  return false;
}

bool robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::ReactivationFunction() {
  return false;
}

double robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::SampleDistribution() {
  return TheDistribution->Deterministic(timeDistributionParameter0());
}

double *robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::ReturnDistributionParameters() {
  TheDistributionParameters[0] = timeDistributionParameter0();
  return TheDistributionParameters;
}

int robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::Rank() {
  return 1;
}

bool robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::preconditionsMet() {
return (!Money->Mark() && CustomerInformation->Mark());
  return true;
}

void robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::executeEffects() {

}

double robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::getCost() {
return 0;
}

double robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::getOutcomeProbability() {
return 1;
}

double robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::getDetection() {
return 0;
}

/*====================== ImpersonateCustomerToObtainMoneyOutcome1Step ========================*/

robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::ImpersonateCustomerToObtainMoneyOutcome1Step() {
  TheDistributionParameters = new double[1];
  commonInit("ImpersonateCustomerToObtainMoneyOutcome1Step", 2, Deterministic, RaceEnabled, 7, 1, false);}

robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::~ImpersonateCustomerToObtainMoneyOutcome1Step() {
  delete[] TheDistributionParameters;
}

void robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::LinkVariables() {
  Money->Register(&Money_Mobius_Mark);
  CustomerInformation->Register(&CustomerInformation_Mobius_Mark);
  ImpersonateCustomerToObtainMoneyChosen->Register(&ImpersonateCustomerToObtainMoneyChosen_Mobius_Mark);
  DoNothingWeight->Register(&DoNothingWeight_Mobius_Mark);
  WriteDownAccountInformationWeight->Register(&WriteDownAccountInformationWeight_Mobius_Mark);
  ImpersonateCustomerToObtainMoneyWeight->Register(&ImpersonateCustomerToObtainMoneyWeight_Mobius_Mark);
  MakeDecision->Register(&MakeDecision_Mobius_Mark);

}

bool robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(ImpersonateCustomerToObtainMoneyChosen_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::timeDistributionParameter0() {
return 10;
}

double robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::Weight() {
return 1;
}

bool robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::ReactivationPredicate() {
  return false;
}

bool robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::ReactivationFunction() {
  return false;
}

double robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::SampleDistribution() {
  return TheDistribution->Deterministic(timeDistributionParameter0());
}

double *robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::ReturnDistributionParameters() {
  TheDistributionParameters[0] = timeDistributionParameter0();
  return TheDistributionParameters;
}

int robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::Rank() {
  return 1;
}

bool robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::preconditionsMet() {
return (!Money->Mark() && CustomerInformation->Mark());
  return true;
}

void robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::executeEffects() {

}

double robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::getCost() {
return 0;
}

double robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::getOutcomeProbability() {
return 1;
}

double robberyADVISE::ImpersonateCustomerToObtainMoneyOutcome1Step::getDetection() {
return 0;
}

/*====================== ImpersonateCustomerToObtainMoneyFailureStep ========================*/

robberyADVISE::ImpersonateCustomerToObtainMoneyFailureStep::ImpersonateCustomerToObtainMoneyFailureStep() {
  TheDistributionParameters = new double[1];
  commonInit("ImpersonateCustomerToObtainMoneyFailureStep", 2, Deterministic, RaceEnabled, 7, 1, false);}

robberyADVISE::ImpersonateCustomerToObtainMoneyFailureStep::~ImpersonateCustomerToObtainMoneyFailureStep() {
  delete[] TheDistributionParameters;
}

void robberyADVISE::ImpersonateCustomerToObtainMoneyFailureStep::LinkVariables() {
  Money->Register(&Money_Mobius_Mark);
  CustomerInformation->Register(&CustomerInformation_Mobius_Mark);
  ImpersonateCustomerToObtainMoneyChosen->Register(&ImpersonateCustomerToObtainMoneyChosen_Mobius_Mark);
  DoNothingWeight->Register(&DoNothingWeight_Mobius_Mark);
  WriteDownAccountInformationWeight->Register(&WriteDownAccountInformationWeight_Mobius_Mark);
  ImpersonateCustomerToObtainMoneyWeight->Register(&ImpersonateCustomerToObtainMoneyWeight_Mobius_Mark);
  MakeDecision->Register(&MakeDecision_Mobius_Mark);

}

bool robberyADVISE::ImpersonateCustomerToObtainMoneyFailureStep::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(ImpersonateCustomerToObtainMoneyChosen_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robberyADVISE::ImpersonateCustomerToObtainMoneyFailureStep::timeDistributionParameter0() {
return 10;
}

double robberyADVISE::ImpersonateCustomerToObtainMoneyFailureStep::Weight() {
return 0.3;
}

bool robberyADVISE::ImpersonateCustomerToObtainMoneyFailureStep::ReactivationPredicate() {
  return false;
}

bool robberyADVISE::ImpersonateCustomerToObtainMoneyFailureStep::ReactivationFunction() {
  return false;
}

double robberyADVISE::ImpersonateCustomerToObtainMoneyFailureStep::SampleDistribution() {
  return TheDistribution->Deterministic(timeDistributionParameter0());
}

double *robberyADVISE::ImpersonateCustomerToObtainMoneyFailureStep::ReturnDistributionParameters() {
  TheDistributionParameters[0] = timeDistributionParameter0();
  return TheDistributionParameters;
}

int robberyADVISE::ImpersonateCustomerToObtainMoneyFailureStep::Rank() {
  return 1;
}

bool robberyADVISE::ImpersonateCustomerToObtainMoneyFailureStep::preconditionsMet() {
return (!Money->Mark() && CustomerInformation->Mark());
  return true;
}

void robberyADVISE::ImpersonateCustomerToObtainMoneyFailureStep::executeEffects() {

}

double robberyADVISE::ImpersonateCustomerToObtainMoneyFailureStep::getCost() {
return 0;
}

double robberyADVISE::ImpersonateCustomerToObtainMoneyFailureStep::getOutcomeProbability() {
return 0.3;
}

double robberyADVISE::ImpersonateCustomerToObtainMoneyFailureStep::getDetection() {
return 0.9;
}

/*====================== ImpersonateCustomerToObtainMoneySuccessStep ========================*/

robberyADVISE::ImpersonateCustomerToObtainMoneySuccessStep::ImpersonateCustomerToObtainMoneySuccessStep() {
  TheDistributionParameters = new double[1];
  commonInit("ImpersonateCustomerToObtainMoneySuccessStep", 2, Deterministic, RaceEnabled, 7, 1, false);}

robberyADVISE::ImpersonateCustomerToObtainMoneySuccessStep::~ImpersonateCustomerToObtainMoneySuccessStep() {
  delete[] TheDistributionParameters;
}

void robberyADVISE::ImpersonateCustomerToObtainMoneySuccessStep::LinkVariables() {
  Money->Register(&Money_Mobius_Mark);
  CustomerInformation->Register(&CustomerInformation_Mobius_Mark);
  ImpersonateCustomerToObtainMoneyChosen->Register(&ImpersonateCustomerToObtainMoneyChosen_Mobius_Mark);
  DoNothingWeight->Register(&DoNothingWeight_Mobius_Mark);
  WriteDownAccountInformationWeight->Register(&WriteDownAccountInformationWeight_Mobius_Mark);
  ImpersonateCustomerToObtainMoneyWeight->Register(&ImpersonateCustomerToObtainMoneyWeight_Mobius_Mark);
  MakeDecision->Register(&MakeDecision_Mobius_Mark);

}

bool robberyADVISE::ImpersonateCustomerToObtainMoneySuccessStep::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(ImpersonateCustomerToObtainMoneyChosen_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robberyADVISE::ImpersonateCustomerToObtainMoneySuccessStep::timeDistributionParameter0() {
return 10;
}

double robberyADVISE::ImpersonateCustomerToObtainMoneySuccessStep::Weight() {
return 0.7;
}

bool robberyADVISE::ImpersonateCustomerToObtainMoneySuccessStep::ReactivationPredicate() {
  return false;
}

bool robberyADVISE::ImpersonateCustomerToObtainMoneySuccessStep::ReactivationFunction() {
  return false;
}

double robberyADVISE::ImpersonateCustomerToObtainMoneySuccessStep::SampleDistribution() {
  return TheDistribution->Deterministic(timeDistributionParameter0());
}

double *robberyADVISE::ImpersonateCustomerToObtainMoneySuccessStep::ReturnDistributionParameters() {
  TheDistributionParameters[0] = timeDistributionParameter0();
  return TheDistributionParameters;
}

int robberyADVISE::ImpersonateCustomerToObtainMoneySuccessStep::Rank() {
  return 1;
}

bool robberyADVISE::ImpersonateCustomerToObtainMoneySuccessStep::preconditionsMet() {
return (!Money->Mark() && CustomerInformation->Mark());
  return true;
}

void robberyADVISE::ImpersonateCustomerToObtainMoneySuccessStep::executeEffects() {
Money->Mark() = true;
}

double robberyADVISE::ImpersonateCustomerToObtainMoneySuccessStep::getCost() {
return 0;
}

double robberyADVISE::ImpersonateCustomerToObtainMoneySuccessStep::getOutcomeProbability() {
return 0.7;
}

double robberyADVISE::ImpersonateCustomerToObtainMoneySuccessStep::getDetection() {
return 0;
}

/*****************************************************************/
/*                   Adversary Decisions                         */
/*****************************************************************/

/*====================== DoNothingAdversaryDecision ========================*/

robberyADVISE::DoNothingAdversaryDecision::DoNothingAdversaryDecision() {
  commonInit("DoNothingAdversaryDecision", 3, Instantaneous, RaceEnabled, 2, 1, false);
}

robberyADVISE::DoNothingAdversaryDecision::~DoNothingAdversaryDecision() {
}

void robberyADVISE::DoNothingAdversaryDecision::LinkVariables() {
  MakeDecision->Register(&MakeDecision_Mobius_Mark);
  DoNothingChosen->Register(&DoNothingChosen_Mobius_Mark);
  DoNothingWeight->Register(&DoNothingWeight_Mobius_Mark);
}

bool robberyADVISE::DoNothingAdversaryDecision::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(MakeDecision_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robberyADVISE::DoNothingAdversaryDecision::Weight() {
  return DoNothingWeight->Mark();
}

bool robberyADVISE::DoNothingAdversaryDecision::ReactivationPredicate() {
  return false;
}

bool robberyADVISE::DoNothingAdversaryDecision::ReactivationFunction() {
  return false;
}

double robberyADVISE::DoNothingAdversaryDecision::SampleDistribution() {
  return 0;
}

double* robberyADVISE::DoNothingAdversaryDecision::ReturnDistributionParameters() {
  return NULL;
}

int robberyADVISE::DoNothingAdversaryDecision::Rank() {
  return 1;
}

BaseActionClass* robberyADVISE::DoNothingAdversaryDecision::Fire() {
  (*(MakeDecision_Mobius_Mark))--;
  (*(DoNothingWeight_Mobius_Mark))--;
  (*(DoNothingChosen_Mobius_Mark))++;
  return this;
}

/*====================== WriteDownAccountInformationAdversaryDecision ========================*/

robberyADVISE::WriteDownAccountInformationAdversaryDecision::WriteDownAccountInformationAdversaryDecision() {
  commonInit("WriteDownAccountInformationAdversaryDecision", 3, Instantaneous, RaceEnabled, 2, 1, false);
}

robberyADVISE::WriteDownAccountInformationAdversaryDecision::~WriteDownAccountInformationAdversaryDecision() {
}

void robberyADVISE::WriteDownAccountInformationAdversaryDecision::LinkVariables() {
  MakeDecision->Register(&MakeDecision_Mobius_Mark);
  WriteDownAccountInformationChosen->Register(&WriteDownAccountInformationChosen_Mobius_Mark);
  WriteDownAccountInformationWeight->Register(&WriteDownAccountInformationWeight_Mobius_Mark);
}

bool robberyADVISE::WriteDownAccountInformationAdversaryDecision::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(MakeDecision_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robberyADVISE::WriteDownAccountInformationAdversaryDecision::Weight() {
  return WriteDownAccountInformationWeight->Mark();
}

bool robberyADVISE::WriteDownAccountInformationAdversaryDecision::ReactivationPredicate() {
  return false;
}

bool robberyADVISE::WriteDownAccountInformationAdversaryDecision::ReactivationFunction() {
  return false;
}

double robberyADVISE::WriteDownAccountInformationAdversaryDecision::SampleDistribution() {
  return 0;
}

double* robberyADVISE::WriteDownAccountInformationAdversaryDecision::ReturnDistributionParameters() {
  return NULL;
}

int robberyADVISE::WriteDownAccountInformationAdversaryDecision::Rank() {
  return 1;
}

BaseActionClass* robberyADVISE::WriteDownAccountInformationAdversaryDecision::Fire() {
  (*(MakeDecision_Mobius_Mark))--;
  (*(WriteDownAccountInformationWeight_Mobius_Mark))--;
  (*(WriteDownAccountInformationChosen_Mobius_Mark))++;
  return this;
}

/*====================== ImpersonateCustomerToObtainMoneyAdversaryDecision ========================*/

robberyADVISE::ImpersonateCustomerToObtainMoneyAdversaryDecision::ImpersonateCustomerToObtainMoneyAdversaryDecision() {
  commonInit("ImpersonateCustomerToObtainMoneyAdversaryDecision", 3, Instantaneous, RaceEnabled, 2, 1, false);
}

robberyADVISE::ImpersonateCustomerToObtainMoneyAdversaryDecision::~ImpersonateCustomerToObtainMoneyAdversaryDecision() {
}

void robberyADVISE::ImpersonateCustomerToObtainMoneyAdversaryDecision::LinkVariables() {
  MakeDecision->Register(&MakeDecision_Mobius_Mark);
  ImpersonateCustomerToObtainMoneyChosen->Register(&ImpersonateCustomerToObtainMoneyChosen_Mobius_Mark);
  ImpersonateCustomerToObtainMoneyWeight->Register(&ImpersonateCustomerToObtainMoneyWeight_Mobius_Mark);
}

bool robberyADVISE::ImpersonateCustomerToObtainMoneyAdversaryDecision::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(MakeDecision_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robberyADVISE::ImpersonateCustomerToObtainMoneyAdversaryDecision::Weight() {
  return ImpersonateCustomerToObtainMoneyWeight->Mark();
}

bool robberyADVISE::ImpersonateCustomerToObtainMoneyAdversaryDecision::ReactivationPredicate() {
  return false;
}

bool robberyADVISE::ImpersonateCustomerToObtainMoneyAdversaryDecision::ReactivationFunction() {
  return false;
}

double robberyADVISE::ImpersonateCustomerToObtainMoneyAdversaryDecision::SampleDistribution() {
  return 0;
}

double* robberyADVISE::ImpersonateCustomerToObtainMoneyAdversaryDecision::ReturnDistributionParameters() {
  return NULL;
}

int robberyADVISE::ImpersonateCustomerToObtainMoneyAdversaryDecision::Rank() {
  return 1;
}

BaseActionClass* robberyADVISE::ImpersonateCustomerToObtainMoneyAdversaryDecision::Fire() {
  (*(MakeDecision_Mobius_Mark))--;
  (*(ImpersonateCustomerToObtainMoneyWeight_Mobius_Mark))--;
  (*(ImpersonateCustomerToObtainMoneyChosen_Mobius_Mark))++;
  return this;
}

