#ifndef robberyADVISE_H_
#define robberyADVISE_H_

#include "Cpp/Simulator/UserDistributions.h"
#include "Cpp/BaseClasses/GlobalVariables.h"
#include "Cpp/BaseClasses/PostselectGroup.h"
#include "Cpp/BaseClasses/PreselectGroup.h"
#include "Cpp/BaseClasses/atomic/advise/ADVISEModel.h"
#include "Cpp/BaseClasses/atomic/advise/Access.h"
#include "Cpp/BaseClasses/atomic/advise/AdversaryDecision.h"
#include "Cpp/BaseClasses/atomic/advise/BeginAdversaryDecision.h"
#include "Cpp/BaseClasses/atomic/advise/Goal.h"
#include "Cpp/BaseClasses/atomic/advise/Knowledge.h"
#include "Cpp/BaseClasses/atomic/advise/Skill.h"
#include "Cpp/BaseClasses/atomic/advise/Step.h"
#include "Cpp/BaseClasses/atomic/advise/StepChosen.h"
#include "Cpp/BaseClasses/atomic/advise/StepWeight.h"
#include <limits.h>
#include <math.h>
extern UserDistributions* TheDistribution;

/*********************************************************************
               robberyADVISE Submodel Definition                   
*********************************************************************/

class robberyADVISE : public ADVISEModel {
public:

class DoNothingAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  StepChosen *DoNothingChosen;
  short *DoNothingChosen_Mobius_Mark;
  StepWeight *DoNothingWeight;
  short *DoNothingWeight_Mobius_Mark;
  double *TheDistributionParameters;

  DoNothingAdversaryDecision();
  ~DoNothingAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // DoNothingAdversaryDecision

class WriteDownAccountInformationAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  StepChosen *WriteDownAccountInformationChosen;
  short *WriteDownAccountInformationChosen_Mobius_Mark;
  StepWeight *WriteDownAccountInformationWeight;
  short *WriteDownAccountInformationWeight_Mobius_Mark;
  double *TheDistributionParameters;

  WriteDownAccountInformationAdversaryDecision();
  ~WriteDownAccountInformationAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // WriteDownAccountInformationAdversaryDecision

class ImpersonateCustomerToObtainMoneyAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  StepChosen *ImpersonateCustomerToObtainMoneyChosen;
  short *ImpersonateCustomerToObtainMoneyChosen_Mobius_Mark;
  StepWeight *ImpersonateCustomerToObtainMoneyWeight;
  short *ImpersonateCustomerToObtainMoneyWeight_Mobius_Mark;
  double *TheDistributionParameters;

  ImpersonateCustomerToObtainMoneyAdversaryDecision();
  ~ImpersonateCustomerToObtainMoneyAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // ImpersonateCustomerToObtainMoneyAdversaryDecision

class DoNothingOutcome1Step : public Step {
public:

  StepChosen *DoNothingChosen;
  short *DoNothingChosen_Mobius_Mark;
  StepWeight *DoNothingWeight;
  short *DoNothingWeight_Mobius_Mark;
  StepWeight *WriteDownAccountInformationWeight;
  short *WriteDownAccountInformationWeight_Mobius_Mark;
  StepWeight *ImpersonateCustomerToObtainMoneyWeight;
  short *ImpersonateCustomerToObtainMoneyWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  double *TheDistributionParameters;

  DoNothingOutcome1Step();
  ~DoNothingOutcome1Step();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // DoNothingOutcome1Step

class DoNothingOutcome1Step : public Step {
public:

  StepChosen *DoNothingChosen;
  short *DoNothingChosen_Mobius_Mark;
  StepWeight *DoNothingWeight;
  short *DoNothingWeight_Mobius_Mark;
  StepWeight *WriteDownAccountInformationWeight;
  short *WriteDownAccountInformationWeight_Mobius_Mark;
  StepWeight *ImpersonateCustomerToObtainMoneyWeight;
  short *ImpersonateCustomerToObtainMoneyWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  double *TheDistributionParameters;

  DoNothingOutcome1Step();
  ~DoNothingOutcome1Step();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // DoNothingOutcome1Step

class DoNothingOutcome1Step : public Step {
public:

  StepChosen *DoNothingChosen;
  short *DoNothingChosen_Mobius_Mark;
  StepWeight *DoNothingWeight;
  short *DoNothingWeight_Mobius_Mark;
  StepWeight *WriteDownAccountInformationWeight;
  short *WriteDownAccountInformationWeight_Mobius_Mark;
  StepWeight *ImpersonateCustomerToObtainMoneyWeight;
  short *ImpersonateCustomerToObtainMoneyWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  double *TheDistributionParameters;

  DoNothingOutcome1Step();
  ~DoNothingOutcome1Step();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // DoNothingOutcome1Step

class WriteDownAccountInformationOutcome1Step : public Step {
public:

  Knowledge *CustomerInformation;
  short* CustomerInformation_Mobius_Mark;
  Knowledge *InsiderKnowledge;
  short* InsiderKnowledge_Mobius_Mark;
  StepChosen *WriteDownAccountInformationChosen;
  short *WriteDownAccountInformationChosen_Mobius_Mark;
  StepWeight *DoNothingWeight;
  short *DoNothingWeight_Mobius_Mark;
  StepWeight *WriteDownAccountInformationWeight;
  short *WriteDownAccountInformationWeight_Mobius_Mark;
  StepWeight *ImpersonateCustomerToObtainMoneyWeight;
  short *ImpersonateCustomerToObtainMoneyWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  double *TheDistributionParameters;

  WriteDownAccountInformationOutcome1Step();
  ~WriteDownAccountInformationOutcome1Step();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // WriteDownAccountInformationOutcome1Step

class ImpersonateCustomerToObtainMoneyOutcome1Step : public Step {
public:

  Goal *Money;
  short* Money_Mobius_Mark;
  Knowledge *CustomerInformation;
  short* CustomerInformation_Mobius_Mark;
  StepChosen *ImpersonateCustomerToObtainMoneyChosen;
  short *ImpersonateCustomerToObtainMoneyChosen_Mobius_Mark;
  StepWeight *DoNothingWeight;
  short *DoNothingWeight_Mobius_Mark;
  StepWeight *WriteDownAccountInformationWeight;
  short *WriteDownAccountInformationWeight_Mobius_Mark;
  StepWeight *ImpersonateCustomerToObtainMoneyWeight;
  short *ImpersonateCustomerToObtainMoneyWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  double *TheDistributionParameters;

  ImpersonateCustomerToObtainMoneyOutcome1Step();
  ~ImpersonateCustomerToObtainMoneyOutcome1Step();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // ImpersonateCustomerToObtainMoneyOutcome1Step

class ImpersonateCustomerToObtainMoneyOutcome1Step : public Step {
public:

  Goal *Money;
  short* Money_Mobius_Mark;
  Knowledge *CustomerInformation;
  short* CustomerInformation_Mobius_Mark;
  StepChosen *ImpersonateCustomerToObtainMoneyChosen;
  short *ImpersonateCustomerToObtainMoneyChosen_Mobius_Mark;
  StepWeight *DoNothingWeight;
  short *DoNothingWeight_Mobius_Mark;
  StepWeight *WriteDownAccountInformationWeight;
  short *WriteDownAccountInformationWeight_Mobius_Mark;
  StepWeight *ImpersonateCustomerToObtainMoneyWeight;
  short *ImpersonateCustomerToObtainMoneyWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  double *TheDistributionParameters;

  ImpersonateCustomerToObtainMoneyOutcome1Step();
  ~ImpersonateCustomerToObtainMoneyOutcome1Step();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // ImpersonateCustomerToObtainMoneyOutcome1Step

class ImpersonateCustomerToObtainMoneyFailureStep : public Step {
public:

  Goal *Money;
  short* Money_Mobius_Mark;
  Knowledge *CustomerInformation;
  short* CustomerInformation_Mobius_Mark;
  StepChosen *ImpersonateCustomerToObtainMoneyChosen;
  short *ImpersonateCustomerToObtainMoneyChosen_Mobius_Mark;
  StepWeight *DoNothingWeight;
  short *DoNothingWeight_Mobius_Mark;
  StepWeight *WriteDownAccountInformationWeight;
  short *WriteDownAccountInformationWeight_Mobius_Mark;
  StepWeight *ImpersonateCustomerToObtainMoneyWeight;
  short *ImpersonateCustomerToObtainMoneyWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  double *TheDistributionParameters;

  ImpersonateCustomerToObtainMoneyFailureStep();
  ~ImpersonateCustomerToObtainMoneyFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // ImpersonateCustomerToObtainMoneyFailureStep

class ImpersonateCustomerToObtainMoneySuccessStep : public Step {
public:

  Goal *Money;
  short* Money_Mobius_Mark;
  Knowledge *CustomerInformation;
  short* CustomerInformation_Mobius_Mark;
  StepChosen *ImpersonateCustomerToObtainMoneyChosen;
  short *ImpersonateCustomerToObtainMoneyChosen_Mobius_Mark;
  StepWeight *DoNothingWeight;
  short *DoNothingWeight_Mobius_Mark;
  StepWeight *WriteDownAccountInformationWeight;
  short *WriteDownAccountInformationWeight_Mobius_Mark;
  StepWeight *ImpersonateCustomerToObtainMoneyWeight;
  short *ImpersonateCustomerToObtainMoneyWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  double *TheDistributionParameters;

  ImpersonateCustomerToObtainMoneySuccessStep();
  ~ImpersonateCustomerToObtainMoneySuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // ImpersonateCustomerToObtainMoneySuccessStep

  //List of user-specified state variables
  Knowledge *InsiderKnowledge;
  Knowledge *CustomerInformation;
  Goal *Money;
  //List of attack step weight state variables
  StepWeight *DoNothingWeight;
  StepWeight *WriteDownAccountInformationWeight;
  StepWeight *ImpersonateCustomerToObtainMoneyWeight;
  //List of attack step chosen state variables
  StepChosen *DoNothingChosen;
  StepChosen *WriteDownAccountInformationChosen;
  StepChosen *ImpersonateCustomerToObtainMoneyChosen;
  //List of attack steps
  DoNothingOutcome1Step DoNothingOutcome1;
  DoNothingOutcome1Step DoNothingOutcome1;
  DoNothingOutcome1Step DoNothingOutcome1;
  WriteDownAccountInformationOutcome1Step WriteDownAccountInformationOutcome1;
  ImpersonateCustomerToObtainMoneyOutcome1Step ImpersonateCustomerToObtainMoneyOutcome1;
  ImpersonateCustomerToObtainMoneyOutcome1Step ImpersonateCustomerToObtainMoneyOutcome1;
  ImpersonateCustomerToObtainMoneyFailureStep ImpersonateCustomerToObtainMoneyFailure;
  ImpersonateCustomerToObtainMoneySuccessStep ImpersonateCustomerToObtainMoneySuccess;
  DoNothingAdversaryDecision DoNothingAD;
  WriteDownAccountInformationAdversaryDecision WriteDownAccountInformationAD;
  ImpersonateCustomerToObtainMoneyAdversaryDecision ImpersonateCustomerToObtainMoneyAD;
  //Groups for attack steps
  PreselectGroup ImmediateGroup;
  PostselectGroup DoNothingGroup;
  PostselectGroup ImpersonateCustomerToObtainMoneyGroup;
  PostselectGroup AdversaryDecisionGroup;
  robberyADVISE();
  ~robberyADVISE();
  void assignSVsToAttackSteps();
  double convertCostToUtility(double cost);
  double convertDetectionToUtility(double detections);
  double convertPayoffToUtility(double payoff);
  void customInitialization();

protected:
}; // end robberyADVISE

#endif // robberyADVISE_H_
